#include <system.h>
#include <io.h>
#include <stdio.h>

extern "C" void write_buffer( const unsigned int address, const unsigned int data );

static unsigned int image[ 8 ][ 0x2000 ] = { 0, };

void write_buffer( const unsigned int address, const unsigned int data )
{
    image[ ( unsigned int ) ( address / 0x2000 ) ][ ( unsigned int ) ( address % 0x2000 ) ] = data;
}

void write_image( const int& sprite_id, const int& image_id )
{
    IOWR_32DIRECT( VGA_BASE, 0x08, 0xFFFFFFFF );
    for( int i = 0; i < 0x2000; i++ )
    {
        IOWR_32DIRECT( SRAM_BASE, 0x8000 * sprite_id + 4 * i, image[ image_id ][ i ] );
    }
    IOWR_32DIRECT( VGA_BASE, 0x08, 0x00 );
}
